NeuralEngine A Game Engine with embeded Machine Learning algorithms based on Gaussian Processes. |

Private Member Functions | Friends | List of all members
NeuralEngine::MachineLearning::GPModels::VFE::SGPLVM< Scalar > Class Template Reference

Sparse Gaussian Process Latent Variable Model (SGPLVM) with optimization through Variational Free Energy (VFE). More...

`#include <FgVFESparseGPLVM.h>`

Inheritance diagram for NeuralEngine::MachineLearning::GPModels::VFE::SGPLVM< Scalar >:
[legend]
Collaboration diagram for NeuralEngine::MachineLearning::GPModels::VFE::SGPLVM< Scalar >:
[legend]

## Private Member Functions
template<class Archive >
void | serialize (Archive &ar, unsigned int version)

## Friends
class | boost::serialization::access

## Additional Inherited Members
Public Member Functions inherited from NeuralEngine::MachineLearning::GPModels::SparseGPBaseModel< Scalar >
| SparseGPBaseModel (const af::array &Y, const af::array &X, int numInducing=200, LogLikType lType=LogLikType::Gaussian)
| Constructor. More...
| SparseGPBaseModel ()
| Default constructor. More...
virtual | ~SparseGPBaseModel ()
| Destructor. More...
virtual void | PredictF (const af::array &testInputs, af::array &mf, af::array &vf) override
| Predict noise free functions values \(\mathbf{F}_*\). More...
virtual void | SampleY (const af::array inputs, int numSamples, af::array &outFunctions) override
| Generate function samples from posterior. More...
af::array | GetTrainingInputs ()
| Gets training inputs X. More...
void | SetTrainingInputs (af::array &inputs)
| Gets training inputs X. More...
af::array | GetPseudoInputs ()
| Gets pseudo inputs. More...
virtual bool | Init () override
| Initializes the model. More...
virtual int | GetNumParameters () override
| Gets number of parameters. More...
virtual void | SetParameters (const af::array &param) override
| Sets the parameters for each optimization iteration. More...
virtual af::array | GetParameters () override
| Gets the parameters for each optimization iteration. More...
virtual void | UpdateParameters () override
| Updates the parameters. More...
virtual void | FixKernelParameters (bool isfixed)
| Sets fixation for hyperparameters. More...
virtual void | FixInducing (bool isfixed)
| Set fixation for inducing inputs. More...
SparseGPBaseLayer< Scalar > * | GetGPLayer ()
| Gets the gp layer. More...
Public Member Functions inherited from NeuralEngine::MachineLearning::GPModels::GPBaseModel< Scalar >
| GPBaseModel (const af::array &Y, LogLikType lType=LogLikType::Gaussian, ModelType mtype=ModelType::GPR)
| Constructor. More...
| GPBaseModel ()
| Default Constructor. More...
virtual | ~GPBaseModel ()
| Destructor. More...
virtual void | Optimise (OptimizerType method=L_BFGS, Scalar tol=0.0, bool reinit_hypers=true, int maxiter=1000, int mb_size=0, LineSearchType lsType=MoreThuente, bool disp=true, int *cycle=nullptr)
| Optimizes the model parameters for best fit. More...
virtual bool | Init ()
| Initializes the model. More...
virtual void | PredictF (const af::array &testInputs, af::array &mf, af::array &vf)
| Predict noise free functions values \(\mathbf{F}_*\). More...
virtual void | PredictY (const af::array &testInputs, af::array &my, af::array &vy)
| Prediction of test outputs \(\mathbf{Y}_*\). More...
virtual void | SampleY (const af::array inputs, int numSamples, af::array &outFunctions)
| Generate function samples from posterior. More...
virtual void | AddData (const af::array Ytrain)
| Adds training data to the model. More...
af::array | GetTrainingData ()
| Gets the training data set Y. More...
void | SetTrainingData (af::array &data)
| Sets training data Y. More...
virtual int | GetNumParameters ()
| Gets number of parameters. More...
virtual void | SetParameters (const af::array &param)
| Sets the parameters for each optimization iteration. More...
virtual af::array | GetParameters ()
| Gets the parameters for each optimization iteration. More...
virtual void | UpdateParameters ()
| Updates the parameters. More...
virtual void | FixLikelihoodParameters (bool isfixed)
| Sets the likelihood parameters to be fixed or not for optimization. More...
void | SetSegments (af::array segments)
| Sets fixation for hyperparameters. More...
af::array | GetSegments ()
| Gets the start index array for the sequences. More...
Public Member Functions inherited from NeuralEngine::MachineLearning::IModel< Scalar >
virtual Scalar | Function (const af::array &x, af::array &outGradient)
| Cost function the given x inputs. More...
virtual int | GetNumParameters ()=0
| Gets number of parameters to be optimized. More...
virtual void | SetParameters (const af::array &param)=0
| Sets the parameters for each optimization iteration. More...
virtual af::array | GetParameters ()=0
| Gets the parameters for each optimization iteration. More...
virtual void | UpdateParameters ()=0
| Updates the parameters. More...
int | GetDataLenght ()
| Gets data lenght. More...
int | GetDataDimensionality ()
| Gets data dimensionality. More...
ModelType | GetModelType ()
| Gets model type. More...
virtual void | SetBatchSize (int size)
| Sets batch size. More...
int | GetBatchSize ()
| Gets batch size. More...
void | SetIndexes (af::array &indexes)
| Sets the batch indexes. More...
Protected Member Functions inherited from NeuralEngine::MachineLearning::IModel< Scalar >
| IModel (int numData, int numDimension, ModelType type)
| Constructor. More...
Protected Attributes inherited from NeuralEngine::MachineLearning::GPModels::SparseGPBaseModel< Scalar >
int | ik
| number of inducing inputs More...
int | iq
| latent dimension More...
af::array | afX
| training inputs More...
SparseGPBaseLayer< Scalar > * | gpLayer
| gp layer More...
Protected Attributes inherited from NeuralEngine::MachineLearning::GPModels::GPBaseModel< Scalar >
bool | bInit
| check if model is initialized More...
af::array | afY
| training dataset, mean substracted More...
af::array | afBias
| the bias More...
af::array | afSegments
| Index of starting positions for all trials. More...
LikelihoodBaseLayer< Scalar > * | likLayer
| liklihood layer More...
Protected Attributes inherited from NeuralEngine::MachineLearning::IModel< Scalar >
ModelType | mType
int | iN
| dataset length More...
int | iD
| dataset dimension More...
int | iBatchSize
| size of the batch More...
af::array | afIndexes
| indexes of /f$\mathbf{X}/f$ for batch learning More...
af::dtype | m_dType
| floating point precision flag for af::array More...

## Detailed Description

template<typename Scalar>
class NeuralEngine::MachineLearning::GPModels::VFE::SGPLVM< Scalar >

Sparse Gaussian Process Latent Variable Model (SGPLVM) with optimization through Variational Free Energy (VFE).

VFE for SGPLVMs integrates out the input variables and computes/maximizes a lower bound on the exact marginal. This avoids overfitting and enables approximations for not tractable integrals in deeper GP models.

For more information see, http://proceedings.mlr.press/v9/titsias10a/titsias10a.pdf

, 28.02.2018.

Definition at line 41 of file FgVFESparseGPLVM.h.

## Member Function Documentation

## ◆ serialize()

template<typename Scalar >
template<class Archive >

void NeuralEngine::MachineLearning::GPModels::VFE::SGPLVM< Scalar >::serialize | ( | Archive & | ar,
|  | unsigned int | version
| ) |  |
| inline private

Definition at line 51 of file FgVFESparseGPLVM.h.

## Friends And Related Function Documentation

## ◆ boost::serialization::access

template<typename Scalar >

friend class boost::serialization::access
| friend

Definition at line 48 of file FgVFESparseGPLVM.h.

The documentation for this class was generated from the following file:

- FgVFESparseGPLVM.h